import "./form-input-number.css";
import { defineComponent as y, resolveDirective as V, openBlock as a, createElementBlock as r, mergeProps as c, createElementVNode as n, normalizeClass as u, toDisplayString as p, createCommentVNode as d, withModifiers as N, renderSlot as D, withDirectives as k, vModelText as S, createBlock as h, resolveDynamicComponent as f, Fragment as b, createTextVNode as I } from "vue";
import { U as $ } from "../../maska-e074d7a3.js";
import { p as F } from "../../helper-4d4ed314.js";
import { s as L, e as P } from "../../icons-fca12ed8.js";
import { _ as M } from "../../_plugin-vue_export-helper-dad06003.js";
const w = y({
  emits: {
    "update:modelValue": (e) => !0,
    blur: (e) => !0,
    change: (e) => !0,
    focus: (e) => !0,
    input: (e) => !0,
    keydown: (e) => !0
  },
  props: {
    autocomplete: {
      required: !1,
      type: Boolean
    },
    disabled: {
      required: !1,
      type: Boolean
    },
    errorMessage: {
      required: !1,
      type: [String, Function]
    },
    icon: {
      required: !1,
      type: Object
    },
    invalidNumberMessage: {
      default: "Please enter valid numbers",
      type: String
    },
    isError: {
      required: !1,
      type: Boolean
    },
    isFocus: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    max: {
      required: !1,
      type: Number
    },
    maxDecimalPlaces: {
      default: 10,
      type: Number
    },
    min: {
      required: !1,
      type: Number
    },
    modelValue: {
      required: !1,
      type: null
    },
    numberLocale: {
      default: "en-US",
      type: String
    },
    placeholder: {
      required: !1,
      type: String
    },
    readOnly: {
      required: !1,
      type: Boolean
    },
    required: {
      required: !1,
      type: Boolean
    },
    step: {
      default: 1,
      type: Number
    },
    tabindex: {
      required: !1,
      type: Number
    },
    textAlign: {
      default: "left",
      type: String
    },
    value: {
      required: !1,
      type: null
    },
    variant: {
      default: "default",
      required: !1,
      type: String
    },
    withLocale: {
      default: !1,
      type: Boolean
    }
  },
  name: "sb-form-input",
  directives: {
    maska: $
  },
  data() {
    return {
      localIsFocus: !1,
      isInvalidNumber: !1,
      localValue: this.modelValue || this.value || null
    };
  },
  computed: {
    getMaskaOptions() {
      if (!this.withLocale) {
        const e = [
          ...Array(this.maxDecimalPlaces).keys()
        ].map(() => "9").join("");
        return this.maxDecimalPlaces ? {
          mask: `#0.${e}`,
          preProcess: (t) => String(t),
          tokens: {
            "#": {
              optional: !0,
              pattern: /-/
            },
            0: {
              multiple: !0,
              pattern: /[0-9]/
            },
            9: {
              optional: !0,
              pattern: /[0-9]/
            }
          }
        } : {
          mask: "#0",
          preProcess: (t) => String(t),
          tokens: {
            "#": {
              optional: !0,
              pattern: /-/
            },
            0: {
              multiple: !0,
              pattern: /[0-9]/
            }
          }
        };
      }
      return {
        postProcess: (e) => {
          if (e && typeof e < "u" && e !== "") {
            const t = this.getRealValue(
              String(e)
            ), i = Number(
              String(t).split(
                this.numberLocale === "en-US" ? "." : ","
              )[0]
            );
            if (this.maxDecimalPlaces) {
              if (!Number.isNaN(t)) {
                const o = String(e).split(
                  this.numberLocale === "en-US" ? "." : ","
                ), s = o[1];
                return (s == null ? void 0 : s.indexOf("0")) < 1 ? s.length > this.maxDecimalPlaces ? `${o[0]}${this.numberLocale === "en-US" ? "." : ","}${s.substring(
                  0,
                  this.maxDecimalPlaces
                )}` : e : Intl.NumberFormat(this.numberLocale, {
                  maximumFractionDigits: this.maxDecimalPlaces,
                  minimumFractionDigits: 0
                }).format(Number(t));
              }
            } else
              return Intl.NumberFormat(this.numberLocale, {
                maximumFractionDigits: this.maxDecimalPlaces,
                minimumFractionDigits: 0
              }).format(i);
          }
          return e || "";
        },
        preProcess: (e) => String(e).split(/[.,]/g)[0] === "" ? "" : String(e).replace(/[^0-9,.-]/gi, "")
      };
    },
    iconSortDown() {
      return L();
    },
    iconSortUp() {
      return P();
    },
    isFilled() {
      var e;
      return this.localValue !== null && typeof this.localValue < "u" ? typeof this.localValue != "number" ? this.localValue !== "" || ((e = this.localValue) == null ? void 0 : e.length) || Object.keys(this.localValue).length > 0 : !0 : !1;
    }
  },
  methods: {
    getRealValue(e) {
      if (!e || typeof e > "u")
        return null;
      if (e = String(e), this.withLocale) {
        if (this.numberLocale === "en-US" && e.split(".")[0] !== "" && e.split(".")[1] === "" || this.numberLocale === "id-ID" && e.split(",")[0] !== "" && e.split(",")[1] === "" || e === "-")
          return +"-";
      } else
        return e.split(".")[0] !== "" && e.split(".")[1] === "" ? +"-" : Number(e);
      return F(e, this.numberLocale);
    },
    handleBlur(e) {
      this.localIsFocus = !1;
      const t = this.getRealValue(
        this.localValue
      );
      e.target.value = Number.isNaN(t) ? this.localValue : Number(t), this.$emit("blur", e);
    },
    handleClickIcon(e) {
      var t;
      return ((t = this.icon) == null ? void 0 : t.onClick) && this.icon.onClick(e);
    },
    handleClickOutsideInput(e) {
      const t = e.target, i = this.$refs["input-wrapper"];
      t && i && !i.contains(t) && !t.isSameNode(i) && this.toggleFocus(!1);
    },
    handleClickStep(e) {
      const t = this.getRealValue(this.localValue) || 0, i = Number.isNaN(t) ? 0 : t + e;
      t > 0 && t < 1 && i < 0 ? this.localValue = 0 : typeof this.max < "u" && i > this.max ? this.localValue = this.max : typeof this.min < "u" && i < this.min ? this.localValue = this.min : this.withLocale && this.numberLocale === "id-ID" ? this.localValue = Intl.NumberFormat(this.numberLocale, {
        maximumFractionDigits: this.maxDecimalPlaces,
        minimumFractionDigits: 0
      }).format(Number(i)) : this.localValue = i;
    },
    handleErrorMessage() {
      return this.errorMessage ? typeof this.errorMessage == "string" ? this.errorMessage : this.errorMessage(this.localValue) : "";
    },
    handleInputChange(e) {
      const t = this.getRealValue(
        this.localValue
      );
      if (t !== null && typeof this.max < "u" && !Number.isNaN(t) && t > this.max)
        e.target.value = this.max, this.localValue = this.max, this.$emit("update:modelValue", this.max), this.$emit("change", e), this.$emit("input", e);
      else if (t !== null && typeof this.min < "u" && !Number.isNaN(t) && t < this.min)
        e.target.value = this.min, this.localValue = this.min, this.$emit("update:modelValue", this.min), this.$emit("change", e), this.$emit("input", e);
      else {
        const i = Number.isNaN(t) ? this.localValue : t;
        e.target.value = i, this.$emit("update:modelValue", i), this.$emit("change", e), this.$emit("input", e);
      }
    },
    handleInputFocus(e) {
      this.localIsFocus = !0, this.$emit("focus", e);
    },
    handleKeydown(e) {
      if (!this.maxDecimalPlaces && (e.key === "," || e.key === "."))
        e.preventDefault(), e.stopPropagation();
      else if (e.key === "ArrowUp")
        e.preventDefault(), e.stopPropagation(), this.handleClickStep(this.step);
      else if (e.key === "ArrowDown")
        e.preventDefault(), e.stopPropagation(), this.handleClickStep(this.step * -1);
      else if (this.maxDecimalPlaces && this.withLocale && (e.key === "," || e.key === ".")) {
        const t = String(this.localValue);
        if (t) {
          const i = e.target, o = i.selectionStart, s = i.selectionEnd;
          this.numberLocale === "en-US" && e.key === "," ? (e.preventDefault(), e.stopPropagation(), this.localValue = `${t.substr(
            0,
            o
          )}.${t.substr(s)}`, i.selectionEnd = s + 1) : this.numberLocale === "id-ID" && e.key === "." && (e.preventDefault(), e.stopPropagation(), this.localValue = `${t.substr(
            0,
            o
          )},${t.substr(s)}`, i.selectionEnd = s + 1);
        }
      }
      this.$emit("keydown", e);
    },
    handleMouseLeaveIcon(e) {
      var t;
      return ((t = this.icon) == null ? void 0 : t.onMouseLeave) && this.icon.onMouseLeave(e);
    },
    handleMouseOverIcon(e) {
      var t;
      return ((t = this.icon) == null ? void 0 : t.onMouseOver) && this.icon.onMouseOver(e);
    },
    handlePaste(e) {
      const i = (e.clipboardData || window.clipboardData).getData("Text");
      /^-?\d*[.,]?\d*$/.test(i) || e.preventDefault();
    },
    handleValueProp(e) {
      e !== null && typeof e < "u" && String(e) !== "" && this.withLocale && this.numberLocale === "id-ID" && !Number.isNaN(Number(e)) ? this.localValue = Intl.NumberFormat(this.numberLocale, {
        maximumFractionDigits: this.maxDecimalPlaces,
        minimumFractionDigits: 0
      }).format(Number(e)) : this.localValue = e;
    },
    toggleFocus(e, t) {
      if (t) {
        const i = t.target, o = i == null ? void 0 : i.querySelectorAll("input");
        o.length > 0 && o[0].focus();
      }
      this.localIsFocus = e;
    }
  },
  watch: {
    isFocus(e) {
      this.localIsFocus = e;
    },
    modelValue: {
      handler(e) {
        this.handleValueProp(e);
      }
    },
    value: {
      handler(e) {
        this.handleValueProp(e);
      }
    }
  },
  mounted() {
    document.addEventListener(
      "click",
      (e) => this.handleClickOutsideInput(e)
    );
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (e) => this.handleClickOutsideInput(e)
    );
  }
});
const C = {
  key: 0,
  class: "asterisk"
}, q = ["autocomplete", "tabindex"], v = { class: "button-wrapper" }, O = { class: "input-border" }, B = { class: "notch" }, E = {
  key: 0,
  class: "asterisk"
}, U = {
  key: 0,
  class: "error-wrapper"
}, A = { key: 0 }, R = ["innerHTML"];
function T(e, t, i, o, s, j) {
  var m;
  const g = V("maska");
  return a(), r("div", c({
    class: ["input-wrapper number", { error: e.isError, flat: e.variant === "flat" }],
    ref: "input-wrapper"
  }, { ...e.$attrs }), [
    n("div", {
      class: u(["input-group", {
        disabled: e.disabled,
        filled: e.isFilled,
        focus: e.isFocus || e.localIsFocus,
        icon_prepend: !!e.icon || !!e.$slots["icon-slot"],
        readonly: e.readOnly
      }])
    }, [
      e.label ? (a(), r("label", {
        key: 0,
        class: u(["label", { required: e.required }])
      }, [
        n("span", null, p(e.label), 1),
        e.required ? (a(), r("span", C, "*")) : d("", !0)
      ], 2)) : d("", !0),
      e.icon || e.$slots["icon-slot"] ? (a(), r("span", {
        key: 1,
        class: u([{
          "sb-cursor-pointer": (m = e.icon) == null ? void 0 : m.onClick
        }, "icon"]),
        onClick: t[0] || (t[0] = N((...l) => e.handleClickIcon && e.handleClickIcon(...l), ["stop"])),
        onMouseover: t[1] || (t[1] = (...l) => e.handleMouseOverIcon && e.handleMouseOverIcon(...l)),
        onMouseleave: t[2] || (t[2] = (...l) => e.handleMouseLeaveIcon && e.handleMouseLeaveIcon(...l))
      }, [
        D(e.$slots, "icon-slot")
      ], 34)) : d("", !0),
      n("div", {
        class: u(["form-control", ["text", e.textAlign]]),
        onClick: t[9] || (t[9] = (l) => e.toggleFocus(!0, l))
      }, [
        k(n("input", c({
          autocomplete: e.autocomplete ? "on" : "off",
          tabindex: e.readOnly || e.disabled ? -1 : e.tabindex,
          type: "text",
          "onUpdate:modelValue": t[3] || (t[3] = (l) => e.localValue = l)
        }, {
          disabled: e.disabled,
          placeholder: e.placeholder,
          readonly: e.readOnly
        }, {
          onBlur: t[4] || (t[4] = (l) => e.handleBlur(l)),
          onFocus: t[5] || (t[5] = (l) => e.handleInputFocus(l)),
          onInput: () => null,
          onKeydown: t[6] || (t[6] = (l) => e.handleKeydown(l)),
          onChange: t[7] || (t[7] = (l) => e.handleInputChange(l)),
          onPaste: t[8] || (t[8] = (...l) => e.handlePaste && e.handlePaste(...l))
        }), null, 16, q), [
          [g, void 0, e.getMaskaOptions],
          [S, e.localValue]
        ])
      ], 2),
      n("div", v, [
        n("div", {
          class: "button increment",
          onClick: t[10] || (t[10] = (l) => e.handleClickStep(e.step))
        }, [
          (a(), h(f(e.iconSortUp)))
        ]),
        n("div", {
          class: "button decrement",
          onClick: t[11] || (t[11] = (l) => e.handleClickStep(e.step * -1))
        }, [
          (a(), h(f(e.iconSortDown)))
        ])
      ]),
      n("fieldset", O, [
        n("legend", B, [
          n("span", {
            class: u(["notch-label", { "no-label": !e.label || e.label === "" }])
          }, [
            e.label && e.label !== "" ? (a(), r(b, { key: 0 }, [
              n("span", null, p(e.label), 1),
              e.required ? (a(), r("span", E, "*")) : d("", !0)
            ], 64)) : (a(), r(b, { key: 1 }, [
              I("​")
            ], 64))
          ], 2)
        ])
      ])
    ], 2),
    e.isInvalidNumber || e.isError && e.errorMessage ? (a(), r("div", U, [
      e.isInvalidNumber ? (a(), r("span", A, p(e.invalidNumberMessage), 1)) : (a(), r("span", {
        key: 1,
        innerHTML: e.handleErrorMessage()
      }, null, 8, R))
    ])) : d("", !0)
  ], 16);
}
const Q = /* @__PURE__ */ M(w, [["render", T]]);
export {
  Q as default
};
